Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/HiveExperiment.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/HiveExperiment.cs	(revision 4116)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/HiveExperiment.cs	(revision 4116)
@@ -0,0 +1,313 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Optimization;
+using System.Drawing;
+using HeuristicLab.Collections;
+using System.Collections.Generic;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+using System.IO;
+using HeuristicLab.Persistence.Default.Xml;
+using HeuristicLab.PluginInfrastructure;
+using System.Reflection;
+using HeuristicLab.Hive.Contracts.Interfaces;
+using HeuristicLab.Hive.Contracts;
+using System.Threading;
+using HeuristicLab.Tracing;
+
+namespace HeuristicLab.Hive.Experiment {
+  /// <summary>
+  /// An experiment which contains multiple batch runs of algorithms.
+  /// </summary>
+  [Item(itemName, itemDescription)]
+  [Creatable("Testing & Analysis")]
+  [StorableClass]
+  public class HiveExperiment : NamedItem, IExecutable {
+    private const string itemName = "Hive Experiment";
+    private const string itemDescription = "An experiment which contains multiple batch runs of algorithms which are executed in the Hive.";
+    private const int resultPollingIntervalMs = 10000;
+    private const int maxSnapshotRetries = 20;
+
+    private IDictionary<Guid, SerializedJob> jobs = null;
+    private object locker = new object();
+
+    private string serverUrl;
+    public string ServerUrl {
+      get { return serverUrl; }
+      set { serverUrl = value; OnServerUrlChanged(); }
+    }
+    public event EventHandler ServerUrlChanged;
+    protected virtual void OnServerUrlChanged() {
+      EventHandler handler = ServerUrlChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    private string resourceIds;
+    public string ResourceIds {
+      get { return resourceIds; }
+      set { resourceIds = value; OnResourceIdsChanged(); }
+    }
+    public event EventHandler ResourceIdsChanged;
+    protected virtual void OnResourceIdsChanged() {
+      EventHandler handler = ResourceIdsChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public IEnumerable<string> ResourceGroups {
+      get {
+        if (!string.IsNullOrEmpty(resourceIds)) {
+          return resourceIds.Split(';');
+        } else {
+          return new List<string>();
+        }
+      }
+    }
+
+    private HeuristicLab.Optimization.Experiment experiment;
+    public HeuristicLab.Optimization.Experiment Experiment {
+      get { return experiment; }
+      set { experiment = value; OnExperimentChanged(); }
+    }
+    public event EventHandler ExperimentChanged;
+    protected virtual void OnExperimentChanged() {
+      EventHandler handler = ExperimentChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public HiveExperiment()
+      : base(itemName, itemDescription) {
+      this.ServerUrl = HeuristicLab.Hive.Experiment.Properties.Settings.Default.HiveServerUrl;
+      this.ResourceIds = HeuristicLab.Hive.Experiment.Properties.Settings.Default.ResourceIds;
+    }
+
+    #region IExecutable Members
+
+    public event EventHandler<EventArgs<Exception>> ExceptionOccurred;
+
+    public ExecutionState ExecutionState {
+      get { return Core.ExecutionState.Stopped; } // [chn] todo 
+    }
+
+    public event EventHandler ExecutionStateChanged;
+
+    public TimeSpan ExecutionTime {
+      get { return new TimeSpan(); } // [chn] todo 
+    }
+
+    public event EventHandler ExecutionTimeChanged;
+
+    public void Pause() {
+      throw new NotSupportedException();
+    }
+
+    public event EventHandler Paused;
+
+    public void Prepare() {
+
+    }
+
+    public event EventHandler Prepared;
+
+    public void Start() {
+      IExecutionEngineFacade executionEngineFacade = ServiceLocator.CreateExecutionEngineFacade(ServerUrl);
+
+      IList<SerializedJob> serializedJobs = new List<SerializedJob>();
+      foreach (IOptimizer optimizer in Experiment.Optimizers) {
+        serializedJobs.Add(CreateJob(optimizer));
+      }
+
+      jobs = new Dictionary<Guid, SerializedJob>();
+
+      IEnumerable<string> groups = ResourceGroups;
+      foreach (SerializedJob job in serializedJobs) {
+        ResponseObject<JobDto> response = executionEngineFacade.AddJobWithGroupStrings(job, groups);
+        
+        jobs.Add(response.Obj.Id, job);
+        StartResultPollingThread(response.Obj);
+      }
+    }
+
+    public event EventHandler Started;
+
+    public void Stop() {
+      // todo
+    }
+
+    public event EventHandler Stopped;
+    private bool abortRequested;
+
+    #endregion
+
+    private SerializedJob CreateJob(IOptimizer optimizer) {
+      // serialize optimizer
+      MemoryStream memStream = new MemoryStream();
+      XmlGenerator.Serialize(optimizer, memStream);
+
+      // find out which which plugins are needed for the given object
+      List<HivePluginInfoDto> pluginsNeeded = (
+        from p in GetDeclaringPlugins(optimizer.GetType())
+        select new HivePluginInfoDto() {
+          Name = p.Name,
+          Version = p.Version,
+          BuildDate = p.BuildDate,
+        }).ToList();
+
+      JobDto jobDto = new JobDto() {
+        CoresNeeded = 1, // [chn] how to determine real cores needed?
+        PluginsNeeded = pluginsNeeded,
+        State = State.Offline,
+        MemoryNeeded = 0,
+        UserId = Guid.Empty // [chn] set real userid here!
+      };
+
+      SerializedJob serializedJob = new SerializedJob() {
+        JobInfo = jobDto,
+        SerializedJobData = memStream.ToArray()
+      };
+      memStream.Dispose();
+
+      return serializedJob;
+    }
+
+    private void StartResultPollingThread(JobDto job) {
+      Thread t = new Thread(() => {
+        IExecutionEngineFacade executionEngineFacade = ServiceLocator.CreateExecutionEngineFacade(ServerUrl);
+        IOptimizer restoredObject = null;
+
+        do {
+          Thread.Sleep(resultPollingIntervalMs);
+          lock (locker) {
+            if (abortRequested) return;
+
+            ResponseObject<SerializedJob> response = executionEngineFacade.GetLastSerializedResult(job.Id, false, false);
+
+            // loop while 
+            // 1. the user doesn't request an abort 
+            // 2. there is a problem with server communication (success==false)
+            // 3. no result for the job is available yet (response.Obj==null)
+            // 4. the result that we get from the server is a snapshot and not the final result
+            if (response.Success && response.Obj != null && response.StatusMessage != ApplicationConstants.RESPONSE_JOB_RESULT_NOT_YET_HERE) {
+              
+              // [chn] todo: deserialization into interface is not possible! how to find out correct static type?
+              restoredObject = XmlParser.Deserialize<IOptimizer>(new MemoryStream(response.Obj.SerializedJobData));
+            }
+          }
+        } while (restoredObject == null || restoredObject.ExecutionState == Core.ExecutionState.Stopped);
+
+        // job retrieved... replace the existing optimizers with the finished one
+        // todo
+      });
+      
+      Logger.Debug("HiveEngine: Starting results-polling thread");
+      t.Start();
+    }
+
+    #region Required Plugin Search
+    /// <summary>
+    /// Returns a list of plugins in which the type itself and all members 
+    /// of the type are declared. Objectgraph is searched recursively.
+    /// </summary>
+    private IEnumerable<IPluginDescription> GetDeclaringPlugins(Type type) {
+      HashSet<Type> types = new HashSet<Type>();
+      FindTypes(type, types, "HeuristicLab.");
+      return GetDeclaringPlugins(types);
+    }
+
+    /// <summary>
+    /// Returns the plugins (including dependencies) in which the given types are declared
+    /// </summary>
+    private IEnumerable<IPluginDescription> GetDeclaringPlugins(IEnumerable<Type> types) {
+      HashSet<IPluginDescription> plugins = new HashSet<IPluginDescription>();
+      foreach (Type t in types) {
+        FindDeclaringPlugins(ApplicationManager.Manager.GetDeclaringPlugin(t), plugins);
+      }
+      return plugins;
+    }
+
+    /// <summary>
+    /// Finds the dependencies of the given plugin and adds it to the plugins hashset.
+    /// Also searches the dependencies recursively.
+    /// </summary>
+    private void FindDeclaringPlugins(IPluginDescription plugin, HashSet<IPluginDescription> plugins) {
+      if (!plugins.Contains(plugin)) {
+        plugins.Add(plugin);
+        foreach (IPluginDescription dependency in plugin.Dependencies) {
+          FindDeclaringPlugins(dependency, plugins);
+        }
+      }
+    }
+
+    /// <summary>
+    /// Recursively finds all types used in type which are in a namespace which starts with namespaceStart
+    /// Be aware that search is not performed on attributes
+    /// </summary>
+    /// <param name="type">the type to be searched</param>
+    /// <param name="types">found types will be stored there, needed in order to avoid duplicates</param>
+    /// <param name="namespaceStart">only types from namespaces which start with this will be searched and added</param>
+    private void FindTypes(Type type, HashSet<Type> types, string namespaceStart) {
+      if (!types.Contains(type) && type.Namespace.StartsWith(namespaceStart)) {
+        types.Add(type);
+
+        // constructors
+        foreach (ConstructorInfo info in type.GetConstructors()) {
+          foreach (ParameterInfo paramInfo in info.GetParameters()) {
+            FindTypes(paramInfo.ParameterType, types, namespaceStart);
+          }
+        }
+
+        // interfaces
+        foreach (Type t in type.GetInterfaces()) {
+          FindTypes(t, types, namespaceStart);
+        }
+
+        // events
+        foreach (EventInfo info in type.GetEvents()) {
+          FindTypes(info.EventHandlerType, types, namespaceStart);
+          FindTypes(info.DeclaringType, types, namespaceStart);
+        }
+
+        // properties
+        foreach (PropertyInfo info in type.GetProperties()) {
+          FindTypes(info.PropertyType, types, namespaceStart);
+        }
+
+        // fields
+        foreach (FieldInfo info in type.GetFields()) {
+          FindTypes(info.FieldType, types, namespaceStart);
+        }
+
+        // methods
+        foreach (MethodInfo info in type.GetMethods()) {
+          foreach (ParameterInfo paramInfo in info.GetParameters()) {
+            FindTypes(paramInfo.ParameterType, types, namespaceStart);
+          }
+          FindTypes(info.ReturnType, types, namespaceStart);
+        }
+      }
+    }
+    #endregion
+  }
+}
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Properties/AssemblyInfo.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Properties/AssemblyInfo.cs	(revision 4115)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Properties/AssemblyInfo.cs	(revision 4116)
@@ -1,17 +1,40 @@
-﻿using System.Reflection;
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Reflection;
 using System.Runtime.CompilerServices;
 using System.Runtime.InteropServices;
-
+using HeuristicLab.PluginInfrastructure;
+using System.Security;
 // General Information about an assembly is controlled through the following 
 // set of attributes. Change these attribute values to modify the information
 // associated with an assembly.
-[assembly: AssemblyTitle("HeuristicLab.Hive.Experiment-3.3")]
-[assembly: AssemblyDescription("")]
+[assembly: AssemblyTitle("HeuristicLab.Hive.Experiment")]
+[assembly: AssemblyDescription("HeuristicLab experiment for distributed computation")]
 [assembly: AssemblyConfiguration("")]
-[assembly: AssemblyCompany("FH OOE")]
-[assembly: AssemblyProduct("HeuristicLab.Hive.Experiment-3.3")]
-[assembly: AssemblyCopyright("Copyright © FH OOE 2010")]
+[assembly: AssemblyCompany("")]
+[assembly: AssemblyProduct("HeuristicLab")]
+[assembly: AssemblyCopyright("(c) 2002-2008 HEAL")]
 [assembly: AssemblyTrademark("")]
 [assembly: AssemblyCulture("")]
+[assembly: AllowPartiallyTrustedCallers]
 
 // Setting ComVisible to false makes the types in this assembly not visible 
@@ -21,5 +44,5 @@
 
 // The following GUID is for the ID of the typelib if this project is exposed to COM
-[assembly: Guid("b89cec07-9515-4898-8cbf-24fea34b2635")]
+[assembly: Guid("9721605F-C79D-434a-8E42-C0A384477D53")]
 
 // Version information for an assembly consists of the following four values:
@@ -30,7 +53,7 @@
 //      Revision
 //
-// You can specify all the values or you can default the Build and Revision Numbers 
+// You can specify all the values or you can default the Revision and Build Numbers 
 // by using the '*' as shown below:
-// [assembly: AssemblyVersion("1.0.*")]
-[assembly: AssemblyVersion("1.0.0.0")]
-[assembly: AssemblyFileVersion("1.0.0.0")]
+[assembly: AssemblyVersion("3.3.0.4111")]
+[assembly: AssemblyFileVersion("3.3.0.4111")]
+[assembly: AssemblyBuildDate("2010/07/27 18:31:34")]
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Properties/Settings.settings
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Properties/Settings.settings	(revision 4116)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Properties/Settings.settings	(revision 4116)
@@ -0,0 +1,12 @@
+﻿<?xml version='1.0' encoding='utf-8'?>
+<SettingsFile xmlns="http://schemas.microsoft.com/VisualStudio/2004/01/settings" CurrentProfile="(Default)" GeneratedClassNamespace="HeuristicLab.Hive.Experiment.Properties" GeneratedClassName="Settings">
+  <Profiles />
+  <Settings>
+    <Setting Name="HiveServerUrl" Type="System.String" Scope="User">
+      <Value Profile="(Default)">net.tcp://10.42.1.153:9000/ExecutionEngine/ExecutionEngineFacade</Value>
+    </Setting>
+    <Setting Name="ResourceIds" Type="System.String" Scope="User">
+      <Value Profile="(Default)">MyGroup</Value>
+    </Setting>
+  </Settings>
+</SettingsFile>
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/ServiceLocator.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/ServiceLocator.cs	(revision 4116)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/ServiceLocator.cs	(revision 4116)
@@ -0,0 +1,41 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+using HeuristicLab.Hive.Contracts.Interfaces;
+using System.ServiceModel;
+using HeuristicLab.Hive.Contracts;
+
+namespace HeuristicLab.Hive.Experiment {
+  internal class ServiceLocator {
+    internal static IExecutionEngineFacade CreateExecutionEngineFacade(string url) {
+      ChannelFactory<IExecutionEngineFacade> factory =
+        new ChannelFactory<IExecutionEngineFacade>(
+          WcfSettings.GetStreamedBinding(),
+          new EndpointAddress(url));
+
+      return factory.CreateChannel();
+    }
+  }
+}
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Settings.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Settings.cs	(revision 4116)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Settings.cs	(revision 4116)
@@ -0,0 +1,28 @@
+﻿namespace HeuristicLab.Hive.Experiment.Properties {
+    
+    
+    // This class allows you to handle specific events on the settings class:
+    //  The SettingChanging event is raised before a setting's value is changed.
+    //  The PropertyChanged event is raised after a setting's value is changed.
+    //  The SettingsLoaded event is raised after the setting values are loaded.
+    //  The SettingsSaving event is raised before the setting values are saved.
+    internal sealed partial class Settings {
+        
+        public Settings() {
+            // // To add event handlers for saving and changing settings, uncomment the lines below:
+            //
+            // this.SettingChanging += this.SettingChangingEventHandler;
+            //
+            // this.SettingsSaving += this.SettingsSavingEventHandler;
+            //
+        }
+        
+        private void SettingChangingEventHandler(object sender, System.Configuration.SettingChangingEventArgs e) {
+            // Add code to handle the SettingChangingEvent event here.
+        }
+        
+        private void SettingsSavingEventHandler(object sender, System.ComponentModel.CancelEventArgs e) {
+            // Add code to handle the SettingsSaving event here.
+        }
+    }
+}
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Console/3.3/AddJobForm.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Console/3.3/AddJobForm.cs	(revision 4115)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Console/3.3/AddJobForm.cs	(revision 4116)
@@ -110,5 +110,5 @@
         if (numJobs > 0) {
           for (int i = 0; i < numJobs; i++) {
-            JobDto job = new JobDto { State = State.offline, CoresNeeded = 1 };
+            JobDto job = new JobDto { State = State.Offline, CoresNeeded = 1 };
             
             // if project selected (0 -> none)
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Console/3.3/HiveServerManagementConsole.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Console/3.3/HiveServerManagementConsole.cs	(revision 4115)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Console/3.3/HiveServerManagementConsole.cs	(revision 4116)
@@ -109,9 +109,9 @@
     void jdf_NewDataAvailable(object sender, EventArgs e) {
       JobDataFetcher fetcher = (JobDataFetcher) sender;
-      if (fetcher.PollStates.Contains(State.finished)) {
+      if (fetcher.PollStates.Contains(State.Finished)) {
         updateJobListView(fetcher, lv_finishedJobs, 0);
-      } else if(fetcher.PollStates.Contains(State.calculating)) {
+      } else if(fetcher.PollStates.Contains(State.Calculating)) {
         updateJobListView(fetcher, lv_calculatingJobs, 1);
-      } else if (fetcher.PollStates.Contains(State.offline)) {
+      } else if (fetcher.PollStates.Contains(State.Offline)) {
         updateJobListView(fetcher, lv_offlineJobs, 2);
       }
@@ -136,7 +136,7 @@
     private void Init() {
 
-      jdfFinished = new JobDataFetcher(new State[] {State.finished}, 50);
-      jdfCalculating = new JobDataFetcher(new State[] {State.calculating}, 50);
-      jdfOffline = new JobDataFetcher(new State[] {State.offline}, 50);
+      jdfFinished = new JobDataFetcher(new State[] {State.Finished}, 50);
+      jdfCalculating = new JobDataFetcher(new State[] {State.Calculating}, 50);
+      jdfOffline = new JobDataFetcher(new State[] {State.Offline}, 50);
 
       cmb_finishedJob_count.SelectedItem = "50";
@@ -348,6 +348,6 @@
           int percentageUsage = CapacityRam(((ClientDto)resource).NrOfCores, ((ClientDto)resource).NrOfFreeCores);
           int usage = 3;
-          if ((((ClientDto)resource).State != State.offline) &&
-            (((ClientDto)resource).State != State.nullState)) {
+          if ((((ClientDto)resource).State != State.Offline) &&
+            (((ClientDto)resource).State != State.NullState)) {
             if ((percentageUsage >= 0) && (percentageUsage <= 25)) {
               usage = 0;
@@ -419,9 +419,9 @@
       //lvSnapshots.Enabled = true;
 
-      if (job.State == State.offline) {
+      if (job.State == State.Offline) {
         pbJobControl.Image = ilLargeImgJob.Images[2];
-      } else if (job.State == State.calculating) {
+      } else if (job.State == State.Calculating) {
         pbJobControl.Image = ilLargeImgJob.Images[1];
-      } else if (job.State == State.finished) {
+      } else if (job.State == State.Finished) {
         pbJobControl.Image = ilLargeImgJob.Images[0];
       }
@@ -480,5 +480,5 @@
         lvJobDetails.Items.Add(lvi);
 
-        if (job.State == State.finished) {
+        if (job.State == State.Finished) {
           lvi = null;
             lvi = new ListViewItem();
@@ -500,5 +500,5 @@
         int percentageUsage = CapacityRam(currentClient.NrOfCores, currentClient.NrOfFreeCores);
         int usage = 3;
-        if ((currentClient.State != State.offline) && (currentClient.State != State.nullState)) {
+        if ((currentClient.State != State.Offline) && (currentClient.State != State.NullState)) {
           if ((percentageUsage >= 0) && (percentageUsage <= 25)) {
             usage = 0;
@@ -630,5 +630,5 @@
         JobDto selectedJob = (JobDto)jlv.SelectedItems[0].Tag;
 
-        if (selectedJob != null && selectedJob.State == State.calculating) {
+        if (selectedJob != null && selectedJob.State == State.Calculating) {
           jlv.ContextMenuStrip.Items.Add(offlineItemAbortJob);
           jlv.ContextMenuStrip.Items.Add(menuItemGetSnapshot);
@@ -806,5 +806,5 @@
               change = true;
             }
-            if (job.State != State.offline) {
+            if (job.State != State.Offline) {
               if ((!IsEqual(job.Client, jobold.Client)) || (job.State != jobold.State)
                    || (job.Percentage != jobold.Percentage)) {
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Console/3.3/JobListView.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Console/3.3/JobListView.cs	(revision 4115)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Console/3.3/JobListView.cs	(revision 4116)
@@ -40,5 +40,5 @@
       JobDataFetcher datafetcher = (JobDataFetcher) sender;
       this.BeginUpdate();
-      if (datafetcher.PollStates.Contains(State.finished)) {
+      if (datafetcher.PollStates.Contains(State.Finished)) {
         this.Items.Clear();
         ListViewItem lviDummy = new ListViewItem("blahr", 0);
